
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ArtistsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const artists = await db.artists.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        image_source: data.image_source
        ||
        null
            ,
            
        image_url: data.image_url
        ||
        null
            ,
            
        external_url: data.external_url
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        last_synced_at: data.last_synced_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return artists;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const artistsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                image_source: item.image_source
            ||
            null
            ,
            
                image_url: item.image_url
            ||
            null
            ,
            
                external_url: item.external_url
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                last_synced_at: item.last_synced_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const artists = await db.artists.bulkCreate(artistsData, { transaction });

        // For each item created, replace relation files
        

        return artists;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const artists = await db.artists.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.image_source !== undefined) updatePayload.image_source = data.image_source;
        
        
        if (data.image_url !== undefined) updatePayload.image_url = data.image_url;
        
        
        if (data.external_url !== undefined) updatePayload.external_url = data.external_url;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.last_synced_at !== undefined) updatePayload.last_synced_at = data.last_synced_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await artists.update(updatePayload, {transaction});

        
        

        
        

        

        return artists;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const artists = await db.artists.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of artists) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of artists) {
                await record.destroy({transaction});
            }
        });


        return artists;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const artists = await db.artists.findByPk(id, options);

        await artists.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await artists.destroy({
            transaction
        });

        return artists;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const artists = await db.artists.findOne(
            { where },
            { transaction },
        );

        if (!artists) {
            return artists;
        }

        const output = artists.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        output.beatmaps_artist = await artists.getBeatmaps_artist({
            transaction
        });
        
        
        
        output.artist_stats_artist = await artists.getArtist_stats_artist({
            transaction
        });
        
        
        
        
        
        
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'artists',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.image_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'artists',
                        'image_url',
                        filter.image_url,
                    ),
                };
            }
            
            if (filter.external_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'artists',
                        'external_url',
                        filter.external_url,
                    ),
                };
            }
            

            
            

            
            if (filter.last_synced_atRange) {
                const [start, end] = filter.last_synced_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    last_synced_at: {
                    ...where.last_synced_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    last_synced_at: {
                    ...where.last_synced_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.image_source) {
                where = {
                    ...where,
                image_source: filter.image_source,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.artists.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'artists',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.artists.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

